--
-- CIRCUIT_VALIDATION
--
CREATE TABLE CSE.CIRCUIT_VALIDATION
(
  ID_CIRCUIT_VALIDATION NUMBER	NOT NULL ,
  C_CIRCUIT_VALIDATION	VARCHAR2(20) NOT NULL,
  LL_CIRCUIT_VALIDATION	VARCHAR2(100) NOT NULL
);

ALTER TABLE CSE.CIRCUIT_VALIDATION ADD CONSTRAINT PK_CIRCUIT_VALIDATION PRIMARY KEY(ID_CIRCUIT_VALIDATION);
ALTER TABLE CSE.CIRCUIT_VALIDATION  ADD CONSTRAINT UK_CIRCUIT_VALIDATION  UNIQUE (C_CIRCUIT_VALIDATION);

CREATE SEQUENCE CSE.CIRCUIT_VALIDATION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.CIRCUIT_VALIDATION IS 'Table des circuits de validation';    
COMMENT ON COLUMN CSE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION IS 'Clef primaire de la table CIRCUIT_VALIDATION';
COMMENT ON COLUMN CSE.CIRCUIT_VALIDATION.C_CIRCUIT_VALIDATION IS 'Code du circuit de validation';
COMMENT ON COLUMN CSE.CIRCUIT_VALIDATION.LL_CIRCUIT_VALIDATION IS 'Libellé long du circuit de validation';

--
-- ETAPE
--
CREATE TABLE CSE.ETAPE
(
  ID_ETAPE 	 	NUMBER	NOT NULL ,
  C_ETAPE		VARCHAR2(20) NOT NULL,
  LL_ETAPE		VARCHAR2(100) NOT NULL,
  ID_CIRCUIT_VALIDATION	NUMBER NOT NULL,
  TEM_ETAPE_INITIALE VARCHAR2(1) DEFAULT 'N' NOT NULL 
);

ALTER TABLE CSE.ETAPE ADD CONSTRAINT PK_ETAPE PRIMARY KEY(ID_ETAPE);
ALTER TABLE CSE.ETAPE  ADD CONSTRAINT UK_ETAPE_CODE_CIRCUIT  UNIQUE (C_ETAPE, ID_CIRCUIT_VALIDATION);

ALTER TABLE CSE.ETAPE ADD CONSTRAINT FK_ETA_CIRCUIT_VALID FOREIGN KEY (ID_CIRCUIT_VALIDATION) REFERENCES CSE.CIRCUIT_VALIDATION (ID_CIRCUIT_VALIDATION);
ALTER TABLE CSE.ETAPE ADD CONSTRAINT CHK_ETA_TEM_ETAPE_INI CHECK (TEM_ETAPE_INITIALE IN ('O', 'N') );

CREATE INDEX CSE.IDX_ETA_ID_CIRCUIT_VALID ON CSE.ETAPE(ID_CIRCUIT_VALIDATION);

CREATE SEQUENCE CSE.ETAPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.ETAPE IS 'Table des étapes générées(validation, annulation,...)';    
COMMENT ON COLUMN CSE.ETAPE.ID_ETAPE IS 'Clef primaire de la table ETAPE';
COMMENT ON COLUMN CSE.ETAPE.C_ETAPE IS 'Code de l''étape';
COMMENT ON COLUMN CSE.ETAPE.LL_ETAPE IS 'Libellé long de l''étape';
COMMENT ON COLUMN CSE.ETAPE.ID_CIRCUIT_VALIDATION IS 'Référence au circuit de validation (cf. CSE.CIRCUIT_VALIDATION.ID_CIRCUIT_VALIDATION)';
COMMENT ON COLUMN CSE.ETAPE.TEM_ETAPE_INITIALE IS 'Est-ce que c''est l''étape initiale ? (O:valide, N:invalide)';


--
-- DEMANDE
--
CREATE TABLE CSE.DEMANDE
(
  ID_DEMANDE NUMBER NOT NULL ,
  ID_ETAPE   NUMBER NOT NULL
);

ALTER TABLE CSE.DEMANDE ADD CONSTRAINT PK_DEMANDE PRIMARY KEY(ID_DEMANDE);
ALTER TABLE CSE.DEMANDE ADD CONSTRAINT FK_DEMANDE_ID_ETAPE FOREIGN KEY (ID_ETAPE) REFERENCES CSE.ETAPE (ID_ETAPE);

CREATE INDEX CSE.IDX_DEMANDE_ID_ETAPE ON CSE.DEMANDE(ID_ETAPE);

CREATE SEQUENCE CSE.DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.DEMANDE IS 'Table des demandes en cours';    
COMMENT ON COLUMN CSE.DEMANDE.ID_DEMANDE IS 'Clef primaire de la table DEMANDE';
COMMENT ON COLUMN CSE.DEMANDE.ID_ETAPE IS 'Référence à l''étape en cours (cf. CSE.ETAPE.ID_ETAPE)';


--
-- CHEMIN
--
CREATE TABLE CSE.CHEMIN
(
  ID_CHEMIN 	     NUMBER NOT NULL ,
  ID_ETAPE_DEPART    NUMBER  ,
  ID_ETAPE_ARRIVEE   NUMBER NOT NULL
);

ALTER TABLE CSE.CHEMIN ADD CONSTRAINT PK_CHEMIN PRIMARY KEY(ID_CHEMIN);
ALTER TABLE CSE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES CSE.ETAPE (ID_ETAPE);
ALTER TABLE CSE.CHEMIN ADD CONSTRAINT FK_CHEMIN_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES CSE.ETAPE (ID_ETAPE);

CREATE INDEX CSE.IDX_CHEMIN_ETAPE_DEPART ON CSE.CHEMIN(ID_ETAPE_DEPART);
CREATE INDEX CSE.IDX_CHEMIN_ETAPE_ARRIVEE ON CSE.CHEMIN(ID_ETAPE_ARRIVEE);

CREATE SEQUENCE CSE.CHEMIN_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.CHEMIN IS 'Table des chemins valides';   
COMMENT ON COLUMN CSE.CHEMIN.ID_CHEMIN IS 'Clef primaire de la table CHEMIN'; 
COMMENT ON COLUMN CSE.CHEMIN.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. CSE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN CSE.CHEMIN.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. CSE.ETAPE.ID_ETAPE)';


--
-- HISTORIQUE_DEMANDE
--
CREATE TABLE CSE.HISTORIQUE_DEMANDE
(
  ID_HISTORIQUE_DEMANDE NUMBER NOT NULL ,
  ID_DEMANDE 		NUMBER NOT NULL ,
  ID_ETAPE_DEPART  	NUMBER,
  ID_ETAPE_ARRIVEE   	NUMBER NOT NULL,
  PERS_ID_MODIFICATION 	NUMBER NOT NULL,
  D_MODIFICATION 	DATE DEFAULT SYSDATE NOT NULL
  
);

ALTER TABLE CSE.HISTORIQUE_DEMANDE ADD CONSTRAINT PK_HISTORIQUE_DEMANDE PRIMARY KEY(ID_HISTORIQUE_DEMANDE);
ALTER TABLE CSE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_DEMANDE FOREIGN KEY (ID_DEMANDE) REFERENCES CSE.DEMANDE (ID_DEMANDE);
ALTER TABLE CSE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_DEPART FOREIGN KEY (ID_ETAPE_DEPART) REFERENCES CSE.ETAPE (ID_ETAPE);
ALTER TABLE CSE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_ID_ETAPE_ARRIVEE FOREIGN KEY (ID_ETAPE_ARRIVEE) REFERENCES CSE.ETAPE (ID_ETAPE);
ALTER TABLE CSE.HISTORIQUE_DEMANDE ADD CONSTRAINT FK_HD_PERS_ID_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE INDEX CSE.IDX_HD_ID_DEMANDE ON CSE.HISTORIQUE_DEMANDE(ID_DEMANDE);
CREATE INDEX CSE.IDX_HD_ETAPE_DEPART ON CSE.HISTORIQUE_DEMANDE(ID_ETAPE_DEPART);
CREATE INDEX CSE.IDX_HD_ETAPE_ARRIVEE ON CSE.HISTORIQUE_DEMANDE(ID_ETAPE_ARRIVEE);
CREATE INDEX CSE.IDX_HD_PERS_MODIFICATION ON CSE.HISTORIQUE_DEMANDE(PERS_ID_MODIFICATION);

CREATE SEQUENCE CSE.HISTORIQUE_DEMANDE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE CSE.HISTORIQUE_DEMANDE IS 'Historisation des demandes qui change d''étape'; 
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.ID_HISTORIQUE_DEMANDE IS 'Clef primaire de la table HISTORIQUE_DEMANDE';   
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.ID_DEMANDE IS 'Référence à la demande historisée (cf. CSE.DEMANDE.ID_DEMANDE)';
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.ID_ETAPE_DEPART IS 'Référence à l''étape de départ (cf. CSE.ETAPE.ID_ETAPE), peut être à null si étape initiale';
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.ID_ETAPE_ARRIVEE IS 'Référence à l''étape d''arrivée (cf. CSE.ETAPE.ID_ETAPE)';
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification du statut de la demande';
COMMENT ON COLUMN CSE.HISTORIQUE_DEMANDE.D_MODIFICATION IS 'Date de modification de la demande';
